/* H.323 Call Generator.
 (c) Benny L. Prijono <seventhson@theseventhson.freeserve.co.uk>
 
 Changelog:
 25 Jan 2002 Substantial improvement [Equivalence Pty. Ltd.]
 25 Jan 2000 Update to incorporate openh323 v.01 alpha2 and fix gatekeeper
             related codes [bennylp]
 */

///////////////////////////////////////////////////////////////////////////////

class COH323EndPoint;

class CallThread : public PThread
{
  PCLASSINFO(CallThread, PThread);
  public:
    CallThread(
      unsigned index,
      COH323EndPoint & endPoint,
      const PString & destination,
      unsigned repeat,
      unsigned tmin_call,
      unsigned tmax_call,
      unsigned tmin_wait,
      unsigned tmax_wait
    );
    void Main();
    void Stop();

  protected:
    COH323EndPoint & endPoint;
    PString destination;
    unsigned index;
    unsigned repeat;
    unsigned tmin_call;
    unsigned tmax_call;
    unsigned tmin_wait;
    unsigned tmax_wait;

    PSyncPoint exit;
};

PLIST(CallThreadList, CallThread);


class CallGen323 : public PProcess 
{
  PCLASSINFO(CallGen323, PProcess)

  public:
    CallGen323();
    void Main();

  protected:
    CallThreadList threadList;
};


///////////////////////////////////////////////////////////////////////////////

class COH323EndPoint : public H323EndPoint 
{
  PCLASSINFO(COH323EndPoint, H323EndPoint);
  public:
    // override from H323EndPoint
    virtual void OnConnectionEstablished(
      H323Connection & connection,    /// Connection that was established
      const PString & token           /// Token for identifying connection
    );
    virtual void OnConnectionCleared(
      H323Connection & connection,    /// Connection that was established
      const PString & token           /// Token for identifying connection
    );
    virtual BOOL OpenAudioChannel(
      H323Connection & connection,  /// Connection for the channel
      BOOL isEncoding,              /// Direction of data flow
      unsigned bufferSize,          /// Size of each sound buffer
      H323AudioCodec & codec        /// codec that is doing the opening
    );

    // new functions
    BOOL Initialise(const PArgList & args);

  protected:
    unsigned totalEstablished;
};

///////////////////////////////////////////////////////////////////////////////
